//+------------------------------------------------------------------+
//| Die Strke des Corrected Average (CA) besteht darin,             |
//| dass der aktuelle Wert der Zeitreihe einen von der momentanen    |
//| Volatilitt abhngigen Schwellenwert berschreiten muss,         |
//| damit der Filter steigt bzw. fllt, wodurch Fehlsignale          |
//| in trendschwachen Phasen vermieden werden.                       |
//| -A.Uhl-                                                          |
//+------------------------------------------------------------------+
#property copyright "A.Uhl,  RickD 2006, Alexander Piechotta, mladen"
#property link      "www.forex-tsd.com"
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen
#property indicator_color2  Orange
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0
#property indicator_maximum 1


extern string TimeFrame    = "Current time frame";
extern double HalfPeriod   =  35;
extern int    Price        =  PRICE_CLOSE;
extern int    DeviationsPeriod = 35;
extern int    DeviationsMethod = MODE_SMA;

double MABuf[];
double CABuf[];
double CABufda[];
double CABufdb[];
double slope[];
string indicatorFileName;
bool   returnBars;
int    timeFrame;


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{       
   IndicatorBuffers(5);
   SetIndexBuffer(0, CABufda); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1, CABufdb); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2, CABuf);
   SetIndexBuffer(3, MABuf);
   SetIndexBuffer(4, slope);
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
   IndicatorShortName(timeFrameToString(timeFrame)+" Corrected Average (CA) ("+HalfPeriod+")");
   return(0);
}

int deinit(){return(0);}  

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start() 
{
   int i,j,k,counted_bars = IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;   
           int limit=MathMin(Bars-counted_bars+HalfPeriod,Bars-1);
           if (returnBars) { CABufda[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //

   if (timeFrame != Period())
   {
      limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
      for (i=limit; i>=0; i--)
      {
         int y = iBarShift(NULL,timeFrame,Time[i]);
            slope[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",HalfPeriod,Price,DeviationsPeriod,DeviationsMethod,4,y);
            CABufda[i] = EMPTY_VALUE;
            CABufdb[i] = EMPTY_VALUE;
            if (slope[i] == 1) CABufda[i] = 1;
            if (slope[i] ==-1) CABufdb[i] = 1;
      }
      return(0);  
   }        
   
   //
   //
   //
   //
   //
   //
   
   for ( i=limit; i >= 0; i--)
   {
      double sum  = (HalfPeriod+1)*iMA(NULL,0,1,0,MODE_SMA,Price,i);
      double sumw = (HalfPeriod+1);
         for(j=1, k=HalfPeriod; j<=HalfPeriod; j++, k--)
         {
            sum  += k*iMA(NULL,0,1,0,MODE_SMA,Price,i+j);
            sumw += k;
            if (j<=i)
            {
               sum  += k*iMA(NULL,0,1,0,MODE_SMA,Price,i-j);
               sumw += k;
            }
         }
         MABuf[i] = sum/sumw;
          
         if (i == Bars-1) { CABuf[i] = MABuf[i]; continue;}
         double v1 = MathPow(iStdDev(NULL, 0, DeviationsPeriod,0, DeviationsMethod, Price, i), 2);
         double v2 = MathPow(CABuf[i+1] - MABuf[i], 2);
         double v  = 0;
         if (v2 < v1 || v2 == 0) v = 0; else v = 1 - v1/v2;
      
         CABuf[i]   = CABuf[i+1] + v*(MABuf[i]-CABuf[i+1]);
         CABufda[i] = EMPTY_VALUE;
         CABufdb[i] = EMPTY_VALUE;
         slope[i]   = slope[i+1];
            if (CABuf[i]>CABuf[i+1]) slope[i] =  1;
            if (CABuf[i]<CABuf[i+1]) slope[i] = -1;
            if (slope[i] == 1) CABufda[i] = 1;
            if (slope[i] ==-1) CABufdb[i] = 1;
   }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}